module Tut12 where

{-T12.1-}

{- Expression: 1 + (2 * 3)
 -   2 * 3                      [innermost + outermost]
 -
 - "+" is a primitive operation and thus can only be reduced if it is
 - applied to fully evaluated arguments. Therefore 1 + (2 * 3) as a 
 - whole can not be reduced.
 -
 - Expression: (1 + 2) * (2 + 3)
 -   1 + 2                      [innermost + outermost]
 -   2 + 3                      [innermost + outermost]
 -
 -
 - Expression: fst (1 + 2, 2 + 3)
 -   1 + 2                      [innermost]
 -   2 + 3                      [innermost]
 -   fst (1 + 2, 2 + 3)         [outermost]
 -
 -
 - Expression: fst (snd (1, 2 + 3), 4)
 -   2 + 3                      [innermost]
 -   snd (1, 2 + 3)             [neither]
 -   fst (snd (1, 2 + 3), 4)    [outermost]
 -
 -
 - Expression: (\x -> 1 + x) (2 * 3)
 -   2 * 3                      [innermost]
 -   (\x -> 1 + x) (2 * 3)      [outermost]
 -
 - Note: In general, one cannot reduce inside lambda expressions, so for
 - instance the expression
 -
 -   (\x -> (1 + 2) + x) 3
 -
 - only has a single redex, and 
 -
 -   (\x -> (1 + 2) + x)
 -
 - has none 
 -}

{-T12.2-}

{-
 - map (*2) (1 : threes) !! 1
 - = ((*2) 1 : map (*2) threes) !! 1
 - = map (*2) threes !! (1-1)
 - = map (*2) (3 : threes) !! (1-1)
 - = ((*2) 3 : map (*2) threes) !! (1-1)
 - = ((*2) 3 : map (*2) threes) !! 0
 - = (*2) 3
 - = 3*2
 - = 6
 -
 -
 - (\f -> \x -> x + f 2 + x) (\y -> y * 2) (3 + 1)
 - = (\x -> x + (\y -> y * 2) 2 + x) (3 + 1)
 - = (3 + 1) + (\y -> y * 2) 2 + (3 + 1)
 - = 4 + (\y -> y * 2) 2 + 4 -- Note: sharing
 - = 4 + 2 * 2  + 4
 - = 4 + 4 + 4
 - = 8 + 4
 - = 12
 -
 - head (filter (/=3) threes)
 - head (filter (/=3) (3 : threes))
 - head (filter (/=3) threes)
 -
 -  --> does not terminate
 -}

{-T12.3-}
fibs :: [Integer]
fibs = 0 : 1 : zipWith (+) fibs (tail fibs)

fibs2 :: [Integer]
fibs2 = map fib [0..]
  where
    fib 0 = 0
    fib 1 = 1
    fib n = fibs2 !! (n - 1) + fibs2 !! (n - 2)

fib :: Integer -> Integer
fib 0 = 0
fib 1 = 1
fib n = fib (n - 1) + fib (n - 2)

zipWithN :: ([a] -> b) -> [[a]] -> [b]
zipWithN f xs
  | null xs || any null xs = []
  | otherwise = f (map head xs) : zipWithN f (map tail xs)

nonaccis :: Int -> [Integer]
nonaccis n = replicate (n - 1) 0 ++ [1] ++ nonaccis'
  where
    iterateN n f = take n . iterate f
    nonaccis' = zipWithN sum $ iterateN n tail (nonaccis n)

nonaccis2 :: Int -> [Integer]
nonaccis2 n = map f [0..]
  where
    f x 
      | x < n - 1 = 0
      | x == n - 1 = 1
      | otherwise = sum $ take n $ drop (x - n) (nonaccis2 n)
